module Geo.NextHomeBase 
    ( next_homebase
	, next_homebase_pos
    )
where

import qualified World.Type as W
import Geo.WayFinder

import World.Query.HbContent


import Geo.Type hiding (distance)

import qualified Util.Args as A

-- see under but only Position
next_homebase_pos :: A.Args -> WayGraph Int -> W.Position -> IO(W.Position)
next_homebase_pos args wgraph curhome = 
	do
		(_,_,position) <- next_homebase args wgraph curhome
		return position


-- return the nearest not empty Homebase with Id Distance and Pos
-- assert: Position is a homebase !
next_homebase ::  A.Args -> WayGraph Int -> W.Position -> IO(Int,Int, W.Position)
next_homebase args@A.Args { A.info = info } wgraph curhome =
	do
		let hlist = filter (\ (_, pos) -> pos == curhome ) $ fmToList (homepos wgraph)  
		if null hlist then do return (0, 0, (0,0))
		  else do
			let (cur_home_id,_) = head hlist
			dijk <- dijkstra args cur_home_id
			let bases = map (\ (h, (d,_)) -> 
								d,h, hbContent info $
									lookupWithDefaultFM (homepos wgraph) 
									(0,0) h 
								
							) $ fmToList dijk
			let (aimdist,aimid, _) = minimum $ filter (\ (_,_,f) -> f /= W.False3) bases 
			return (aimid, aimdist, lookupWithDefaultFM (homepos wgraph) (1,1) aimid)
