module Geo.Printer

( print_dmap
, print_wgraph
) where

-- $Log: Printer.hs,v $
-- Revision 1.4  2002/09/02 07:51:31  joe
-- membership as bitstring
--
-- Revision 1.3  2002/09/01 19:18:54  joe
-- oben/unten getauscht
--
-- Revision 1.2  2002/09/01 13:38:56  joe
-- print
--
-- Revision 1.1  2002/09/01 13:00:48  joe
-- printer
--

import World
import Geo.Type
import Geo.Util
import Geo.Make
import Monad (guard)


trim :: Int -> String -> String
trim w cs =
    let n = length cs
    in	replicate (w - n) ' ' ++ cs

print_help :: (Membership -> String) -> Info -> DistanceMap -> IO()
print_help fun info d = do
    let (width, height) = get_field_size info
    let item fun i j = do
	   m<- readArray d (get_index j i width)
	   putStr $ fun m
    let print_line i = do
	    mapM_ ( item (trim 3 . fun) i ) [ 1 .. width ]
	    putStrLn ""
    mapM_ print_line $ reverse [ 1 .. height ]

print_dmap ::  Info -> DistanceMap -> IO()
print_dmap info d = do
    putStrLn $ "base_nr:"
    let showb n = if n == unsegm then "#" else show n
    print_help ( showb . base_nr ) info d
    putStrLn $ "distance:"
    let showd n = if n > 10^6 then "#" else show n
    print_help ( showd . Geo.Type.distance ) info d
    putStrLn $ ""

---------------------------------------------------------------------------

print_wgraph :: (Ord a, Show a) 
	     => WayGraph a -> IO ()
print_wgraph wg = do

    putStrLn $ "nodes: " ++ show (nodes wg)
    putStrLn $ "edges: " ++ show (edges wg)


    let tab = 10
    let vs = setToList $ nodes wg
    let print_edge x y = do
	    let info = case lookupFM ( ewfm wg ) $ kante x y of
			 Nothing -> ""
			 Just s  -> let top : _ = setToList s
				    in	show (len top) 
					++ show (Geo.Type.pos top)
	    putStr $ trim tab $ info
    let print_line v = do
	    mapM_ (print_edge v) vs
	    putStrLn $ " | " ++ show v
    putStrLn $ "graph"
    mapM_ ( putStr . trim tab . show ) vs
    putStrLn $ ""
    mapM_ print_line vs
    putStrLn $ ""    

