module Geo.SimpleFinder 
    ( find_path_by_flood
    , find_path_centre
    , direction
    ) where

-- $Log: SimpleFinder.hs,v $
-- Revision 1.4  2002/09/02 14:30:05  mrahn
-- patti2
--
-- Revision 1.3  2002/09/02 13:58:14  michael
-- export clause extended
--
-- Revision 1.2  2002/09/02 13:45:11  joe
-- direction
--

import qualified World.Type as W
import Geo.Type
import Geo.Gradient
import Geo.Segmentation

import Util.Direction
import Util.Debug


direction ::  (W.Map,W.Info) -> W.Position -> W.Position -> IO [ Direction ]
direction (mappe, info) start target = do
    debug $ unwords [ "user wants direction from", show start
		    , "to", show target 
		    ]
    xs <- find_path_by_flood (mappe,info) start target
    let ds = case xs of 
	   x : y : later -> fromTo x y
	   _ -> []
    debug $ "suggested directions are " ++ show ds
    return ds
	   

fromTo :: W.Position -> W.Position -> [ Direction ]
fromTo (a,b) (c,d) =
    case (compare a c, compare b d) of
	 (EQ, LT) -> [N]
	 (EQ, GT) -> [S]
	 (LT, EQ) -> [E]
	 (GT, EQ) -> [W]
	 _	  -> [ ]


-- find a path between homebases (homebases and position in the middle are given)
find_path_centre :: W.Info -> DistanceMap -> Edge W.Position -> Way -> IO([W.Position])
find_path_centre info dmap edge way = do
      start <- gradient info dmap (pos way) (from edge)
      end   <- gradient info dmap (pos way) (to edge)
      return $ reverse start ++ tail end

-- find a path between two positions in one segment
find_path_by_flood :: (W.Map,W.Info) -> W.Position -> W.Position -> IO([W.Position])
find_path_by_flood (gmap,info) start target = do

    debug $ unwords [ "user wants path from", show start
		    , "to", show target 
		    ]
    (dmap,way) <- shortest_path (gmap,info) (start,target)
    xs <- find_path_centre info dmap Edge { from=start, to=target } way
    debug $ "here it is: " ++ show xs
    return xs




