module Main.Timed 

( stop_after
, timed
)

where


import Util.Debug

import IO
import Monad ( when )
import Concurrent
import Exception hiding ( catch )

import CPUTime
import Time



stop_after :: ( Int, Integer ) -> IO a -> IO a
-- delta : between clock ticks, in microsecs
-- allow : max allowed CPU usage

stop_after args @ ( delta, allow ) action = do

    debug $ "stop_after " ++ show args

    me <- myThreadId

    davor <- getCPUTime
    debug $ "at CPUTime " ++ show davor
    let limit = davor + allow

    let timer = do
	   debug $ "(tick " ; hFlush stdout
           threadDelay $ delta
	   now <- getCPUTime
	   debug $ show now ++ ")"
	   if ( now < limit ) 
	      then timer -- again
	      else do debug "kill action"
		      killThread me

    t <- forkIO $ timer

    x <- action
    debug "kill timer"
    killThread t 
    return x

--------------------------------------------------------

timed :: IO a -> IO (TimeDiff, a)
timed action = do
    before <- getClockTime
    x <- action
    after <-  getClockTime
    return ( diffClockTimes after before, x )





