module Patti.Patti 

( patti
)

where

import Patti.Drops
import Patti.Picks
import Patti.PointstoMove
import World.Type
import World.Move
import World.Query.GetPackPos
import World.Query.GetPackDest
import World.Query.Homebases
import World.Query.Distance
import World.Query.Robo_Pos
import World.Query.GetNeighbors
import Util.Call
import Util.Value
import Util.Command
import Util.RestrictedFiniteMap
import Util.RestrictedSet
import Util.Args
import List                   ( sort )
import Monad
import Util.Debug
import Maybe

------------------------------------------------------------------------------

patti                         :: Suggestor
patti args eat_this           =  do

    let m                     =  mappe args
	i                     =  info args
        ds                    =  drops i
        ( me , not_me )       =  picks i
        dmdiff                =  setToList $ minusSet ( mkSet our_ps )
                                                      ( mkSet me     ) 
        our_ps                =  setToList
			      $  lookupWithDefaultFM
                                 ( robot_packs i )
				 ( emptySet      )
				 ( my_id       i )

    case ds /= [] of
 
     True    -> do
                debug $ "***PATTI: doing the drop"
                eat_this (      max_value , Command 1 ( Drop ds ) )

     _       -> case dmdiff /= [] of
      
      True   -> do
                debug $ "***PATTI: dropping my packages"
                eat_this ( succ min_value , Command 1 ( Drop dmdiff ) )

      _      -> case not_me /= [] of

       True  -> eat_this ( succ min_value , Command 1 ( Pick not_me ) )

       _     -> do

        homes <- homebases (m,i)

        let home              =  head 
			      $  map snd
			      $  sort 
			      $  map ( \ h -> ( distance our_pos h , h ) 
				     ) homes

            our_pos           =  robot_pos ( my_id i ) i
                
            dest              =  fromMaybe 
                                 ( error "upps" )
                                 ( getPackDest i $ head our_ps )

            moves             =  map ( \ d -> ( d , Command 1 ( Move d ) ) ) 
                              .  directions

            directions        =  pointstoMove our_pos

            valid_moves       =  \ pos -> filterM ( \ ( d , c )
					            -> valid_pos (m,i) 
						    $ move d our_pos 
						  )
				          $ moves pos

            goto              =  \ pos -> do
					  vms <- valid_moves pos
					  return $ snd $ head vms

        case our_ps /= [] of

         True -> do debug $ "***PATTI: goto dest: " ++ show dest
                    debug $ "***PATTI: directions " ++ show ( directions dest )
                    cmd       <-  goto dest
                    debug $ "***PATTI: the cmd is " ++ show cmd
                    eat_this ( succ min_value , cmd )

         _    -> do debug $ "***PATTI: goto home: " ++ show home
                    debug $ "***PATTI: directions " ++ show ( directions home )
                    cmd       <-  goto home
                    debug $ "***PATTI: the cmd is " ++ show cmd
                    eat_this ( succ min_value , cmd )

