module Patti.Patti2 

( patti2
)

where

import Patti.Drops
import Patti.Picks
import Geo.SimpleFinder
import World.Type
import World.Move
import World.Query.GetPackDest
import World.Query.Homebases
import World.Query.Distance
import World.Query.Robo_Pos
import World.Query.GetNeighbors
import World.Query.Choose
import Util.Call
import Util.Value
import Util.Command
import Util.RestrictedFiniteMap
import Util.RestrictedSet
import Util.Args
import List                   ( sort )
import Monad
import Util.Debug
import Maybe

------------------------------------------------------------------------------

patti2                        :: Suggestor
patti2 args eat_this          =  do

    let m                     =  mappe args
	i                     =  info args

    homes <- homebases (m,i)
    ( me , not_me ) <- choose args
    
    let ds                    =  drops i
--        ( me , not_me )       =  picks i
        dmdiff                =  setToList $ minusSet ( mkSet our_ps )
                                                      ( mkSet me     ) 
        our_ps                =  setToList
			      $  lookupWithDefaultFM
                                 ( robot_packs i )
				 ( emptySet      )
				 ( my_id       i )

        our_pos               =  robot_pos ( my_id i ) i

        moves to              =  do ds <- direction (m,i) our_pos to
                                    return 
				     $ map ( \ d -> Command 1 ( Move d ) ) ds
 
        goto to               =  do vms <- moves to
				    return $ head vms

        dest                  =  fromMaybe 
                                  ( error "upps" )
                                  ( getPackDest i $ head our_ps )

        home                  =  head 
	  	              $  map snd
			      $  sort 
			      $  map ( \ h -> ( distance our_pos h , h ) 
				     ) homes


    case ds /= [] of
 
     True    -> do
                debug $ "***PATTI: doing the drop"
                eat_this (      max_value , Command 1 ( Drop ds ) )

     _       -> case dmdiff /= [] of
      
      True   -> do
                debug $ "***PATTI: dropping my packages"
                eat_this ( succ min_value , Command 1 ( Drop dmdiff ) )

      _      -> case not_me /= [] of

       True  -> eat_this ( succ min_value , Command 1 ( Pick not_me ) )

       _     -> case our_ps /= [] of

        True -> do debug $ "***PATTI: goto dest: " ++ show dest
                   cmd       <-  goto dest
                   debug $ "***PATTI: the cmd is " ++ show cmd
                   eat_this ( succ min_value , cmd )

        _    -> do debug $ "***PATTI: goto home: " ++ show home
                   cmd       <-  goto home
                   debug $ "***PATTI: the cmd is " ++ show cmd
                   eat_this ( succ min_value , cmd )
