module Patti.PointstoMove where

import World
import Util.Direction
import World.Query

------------------------------------------------------------------------------

pointstoMove                  :: Position -> Position -> [ Direction ]
pointstoMove ( fx , fy ) ( tx , ty )
--Movemaker
--Choose the move if we are just one field away from the destination
    | dx == 0 && dy == 1 && fy < ty    
                              =  [ N , E , S , W ]
    | dx == 0 && dy == 1 && fy > ty    
                              =  [ S , W , N , E ]
    | dy == 0 && dx == 1 && fx < tx    
                              =  [ E , S , W , N ]
    | dy == 0 && dx == 1 && fy > ty    
                              =  [ W , N , E , S ]
--Choose the move in the (global) direction of the target
    | ty > fy && dy >= dx     =  [ N , E , S , W ]
    | ty < fy && dy >= dx     =  [ S , W , N , E ]
    | tx > fy && dy <  dx     =  [ E , S , W , N ]
    | otherwise               =  [ W , N , E , S ]

    where dy                  =  abs $ fy - ty
	  dx                  =  abs $ fx - tx
