module Util.Knapsack where

import List                   ( sortBy )
import World.Type

-------------------------------------------------------------------------------

knapsack                      :: Int             -- Dist , Weight
			         -> [ ( PackID , ( Int , Int ) ) ] 
			         -> [ PackID ]

knapsack can_take xs          =  knaptake can_take 0 [] xs'

    where xs'                 =  sortBy 
		                 ( \ ( _ , ( d1 , w1 ) ) ( _ , ( d2 , w2 ) )
				   -> if d1 == 0 && d2 == 0 
				      then compare w2 w1
				      else compare ( w2 * d1 ) ( w1 * d2 ) 
				 ) $ filter ( (<=can_take) . snd . snd ) xs

          knaptake _ _ pids []
                              =  pids

	  knaptake m h pids ((pid,(_,w)):ys)
	      | h + w > m     =  knaptake m   h         pids              ys
	      | otherwise     =  knaptake m ( h + w ) ( pids ++ [ pid ] ) ys
