module World.Query.Homebases where

import World.Query.Get_Field
import World.Query.GetFieldSize
import World.Type

import Ix
import Data.Array.MArray
import Monad ( when )

import IOExts

-------------------------------------------------------------------------------

homebases_alt                     :: ( Map , Info ) -> IO [ Position ]
homebases_alt (m,i)               =  do

    fs <- mapM ( get_field_with_width m w ) xys

    return $ map fst $ filter ( ( == Base ) . snd ) $ zip xys fs

    where xys                 =  range ((1,1),(w,h))
	  (w,h)               =  get_field_size i


homebases :: ( Map , Info ) -> IO [ Position ]
homebases ( m, i ) = do
    let ( lo, hi ) = bounds m
    let (w,h)               =  get_field_size i
    
    accu <- newIORef []
    let walk i = when ( i <= hi ) $ do
	    x <-  readArray m i
	    when ( x == 64 ) $ do
		ps <- readIORef accu
		let (di, mo) = divMod (i-1) (w + 1)
		writeIORef accu $ (mo+1, di+1) : ps
	    walk $ succ $ i
    walk lo

    readIORef accu
