module World.Query.Near_Robots where

import World.Type
import World.Query.Robo_Pos
import Monad                  ( guard )
import Util.RestrictedFiniteMap

-------------------------------------------------------------------------------

near_robots                   :: Info -> Int -> [ ( RobotID , Position ) ]

near_robots i dist            =  filter ( check . snd ) 
			      $  fmToList 
			      $  robot_poss i
    where ( my_x , my_y )     =  robot_pos ( my_id i ) i
          check (x,y)         =  abs ( x - my_x ) <= dist
			      && abs ( y - my_y ) <= dist

-------------------------------------------------------------------------------

near_robots_alt               :: Info -> Int -> [ ( RobotID , Position ) ]

near_robots_alt i dist        =  do k <- [ -dist .. dist ]
				    j <- [ -dist .. dist ]
				    let (x,y) = ( my_x + k , my_y + j )
				        r = lookupFM robot_by_poss (x,y)
                                    guard $ r /= Nothing
				    let ( Just r' ) = r
				    return (r',(x,y))

    where ( my_x , my_y )     =  robot_pos ( my_id i ) i
          robot_by_poss       =  addListToFM emptyFM 
				 $ map ( \ (x,y) -> (y,x) ) 
				 $ fmToList $ robot_poss i
